# Class OjInputDate

The component WebElement for oj-input-date. Do not instantiate this class directly, instead, use ojInputDate.

#### Hierarchy

- OjInputDateBase
  - OjInputDate

#####
Index

### Constructors

constructor

### Methods

changeMessagesCustom
changeValue
clear
click
findElement
findElements
getAsyncValidators
getAttribute
getAutocomplete
getAutofocus
getConverter
getCssValue
getDatePicker
getDayFormatter
getDayMetaData
getDescribedBy
getDisabled
getDisplayOptions
getDriver
getHelp
getHelpHints
getId
getKeyboardEdit
getLabelEdge
getLabelHint
getLabelledBy
getLocation
getMax
getMessagesCustom
getMin
getName
getPickerAttributes
getPlaceholder
getProperty
getRawValue
getReadonly
getRect
getRenderMode
getRequired
getShadowRoot
getSize
getTagName
getText
getTranslations
getUserAssistanceDensity
getValid
getValidators
getValue
hasSize
hasVisibility
isDisplayed
isEnabled
isSelected
sendKeys
serialize
setProperty
submit
takeScreenshot
whenBusyContextReady
whenReady
buildId
equals
extractId
isId

## Constructors

### constructor

- new OjInputDate(el, locators): OjInputDate

- Constructor. Pass an instance of WebDriver's WebElement that represents the DOM node on which we"ll perform operations.

  #### Parameters

  - ##### el: WebElement

    The basic WebElement with which this WebElement will work.

  - ##### locators: ElementLocators

  #### Returns OjInputDate

  Inherited from OjInputDateBase.constructor

## Methods

### changeMessagesCustom

- changeMessagesCustom(messagesCustom): Promise<void>

- Sets the value of `messagesCustom` property. A list of messages added by an application to the component. See the Help documentation for more information.

  #### Parameters

  - ##### messagesCustom: object[]

    The value to set for `messagesCustom`

  #### Returns Promise<void>

  Inherited from OjInputDateBase.changeMessagesCustom

### changeValue

- changeValue(value): Promise<void>

- Sets the value of `value` property. The value of the input date element, which must be an ISOString. See the Help documentation for more information.

  #### Parameters

  - ##### value: string

    The value to set for `value`

  #### Returns Promise<void>

  Inherited from OjInputDateBase.changeValue

### clear

- clear(): Promise<void>

- ### Inherit Doc

  #### Returns Promise<void>

  Inherited from OjInputDateBase.clear

### click

- click(): Promise<void>

- ### Inherit Doc

  #### Returns Promise<void>

  Inherited from OjInputDateBase.click

### findElement

- findElement(locator): WebElementPromise

- ### Inherit Doc

  #### Parameters

  - ##### locator: Locator

  #### Returns WebElementPromise

  Inherited from OjInputDateBase.findElement

### findElements

- findElements(locator): Promise<WebElement[]>

- ### Inherit Doc

  #### Parameters

  - ##### locator: Locator

  #### Returns Promise<WebElement[]>

  Inherited from OjInputDateBase.findElements

### getAsyncValidators

- getAsyncValidators(): Promise<object[]>

- Gets the value of `asyncValidators` property. Specifies a list of asynchronous validators used by the component when performing validation. Use async-validators when you need to perform some validation work on the server. See the Help documentation for more information.

  ### Deprecated

  Since 8.0.0. Use the validators property instead for either regular Validators or AsyncValidators.

  #### Returns Promise<object[]>

  The value of `asyncValidators` property.

  Inherited from OjInputDateBase.getAsyncValidators

### getAttribute

- getAttribute(attributeName): Promise<string>

- ### Inherit Doc

  #### Parameters

  - ##### attributeName: string

  #### Returns Promise<string>

  Inherited from OjInputDateBase.getAttribute

### getAutocomplete

- getAutocomplete(): Promise<string>

- Gets the value of `autocomplete` property. Specifies a component's autocomplete state. See the Help documentation for more information.

  #### Returns Promise<string>

  The value of `autocomplete` property.

  Inherited from OjInputDateBase.getAutocomplete

### getAutofocus

- getAutofocus(): Promise<boolean>

- Gets the value of `autofocus` property. Specifies whether the component will get input focus when the page is loaded. See the Help documentation for more information.

  #### Returns Promise<boolean>

  The value of `autofocus` property.

  Inherited from OjInputDateBase.getAutofocus

### getConverter

- getConverter(): Promise<object>

- Gets the value of `converter` property. An object that converts the value. See the Help documentation for more information.

  #### Returns Promise<object>

  The value of `converter` property.

  Inherited from OjInputDateBase.getConverter

### getCssValue

- getCssValue(cssStyleProperty): Promise<string>

- ### Inherit Doc

  #### Parameters

  - ##### cssStyleProperty: string

  #### Returns Promise<string>

  Inherited from OjInputDateBase.getCssValue

### getDatePicker

- getDatePicker(): Promise<DatePicker>

- Gets the value of `datePicker` property. An object whose properties describe the appearance and behavior of the date picker. See the Help documentation for more information.

  #### Returns Promise<DatePicker>

  The value of `datePicker` property.

  Inherited from OjInputDateBase.getDatePicker

### getDayFormatter

- getDayFormatter(): Promise<null>

- Gets the value of `dayFormatter` property. Specifies a callback function used when rendering the day. See the Help documentation for more information.

  #### Returns Promise<null>

  The value of `dayFormatter` property.

  Inherited from OjInputDateBase.getDayFormatter

### getDayMetaData

- getDayMetaData(): Promise<object>

- Gets the value of `dayMetaData` property. Specifies additional information to be used when rendering the day. See the Help documentation for more information.

  #### Returns Promise<object>

  The value of `dayMetaData` property.

  Inherited from OjInputDateBase.getDayMetaData

### getDescribedBy

- getDescribedBy(): Promise<string>

- Gets the value of `describedBy` property. The form component's oj-label automatically sets described-by to make it accessible. It is not meant to be set by application developer.

  #### Returns Promise<string>

  The value of `describedBy` property.

  Inherited from OjInputDateBase.getDescribedBy

### getDisabled

- getDisabled(): Promise<boolean>

- Gets the value of `disabled` property. Specifies whether the component is disabled. The default is false.

  #### Returns Promise<boolean>

  The value of `disabled` property.

  Inherited from OjInputDateBase.getDisabled

### getDisplayOptions

- getDisplayOptions(): Promise<DisplayOptions>

- Gets the value of `displayOptions` property. Display options for auxiliary content that determines whether or not it should be displayed.

  #### Returns Promise<DisplayOptions>

  The value of `displayOptions` property.

  Inherited from OjInputDateBase.getDisplayOptions

### getDriver

- getDriver(): WebDriver

- #### Returns WebDriver

  The parent driver for this instance.

  Inherited from OjInputDateBase.getDriver

### getHelp

- getHelp(): Promise<Help>

- Gets the value of `help` property. Form component help information.

  #### Returns Promise<Help>

  The value of `help` property.

  Inherited from OjInputDateBase.getHelp

### getHelpHints

- getHelpHints(): Promise<HelpHints>

- Gets the value of `helpHints` property. Represents hints for an oj-form-layout element to render help information on the label of the editable component.

  #### Returns Promise<HelpHints>

  The value of `helpHints` property.

  Inherited from OjInputDateBase.getHelpHints

### getId

- getId(): Promise<string>

- #### Returns Promise<string>

  A promise that resolves to the server-assigned opaque ID assigned to this element.

  Inherited from OjInputDateBase.getId

### getKeyboardEdit

- getKeyboardEdit(): Promise<string>

- Gets the value of `keyboardEdit` property. Determines if keyboard entry of the text is allowed. When disabled, the picker must be used to select the date. See the Help documentation for more information.

  #### Returns Promise<string>

  The value of `keyboardEdit` property.

  Inherited from OjInputDateBase.getKeyboardEdit

### getLabelEdge

- getLabelEdge(): Promise<string>

- Gets the value of `labelEdge` property. Defines how the label of a component is created. See the Help documentation for more information.

  #### Returns Promise<string>

  The value of `labelEdge` property.

  Inherited from OjInputDateBase.getLabelEdge

### getLabelHint

- getLabelHint(): Promise<string>

- Gets the value of `labelHint` property. Represents a hint for oj-form-layout element to render a label on the editable component.

  #### Returns Promise<string>

  The value of `labelHint` property.

  Inherited from OjInputDateBase.getLabelHint

### getLabelledBy

- getLabelledBy(): Promise<string>

- Gets the value of `labelledBy` property. The oj-label sets the labelledBy property programmatically on the form component. See the Help documentation for more information.

  #### Returns Promise<string>

  The value of `labelledBy` property.

  Inherited from OjInputDateBase.getLabelledBy

### getLocation

- getLocation(): Promise<ILocation>

- ### Inherit Doc

  #### Returns Promise<ILocation>

  Inherited from OjInputDateBase.getLocation

### getMax

- getMax(): Promise<string>

- Gets the value of `max` property. The maximum selectable date, in ISO string format. When set to null, there is no maximum. Since the value becomes a local date with no time once the user interacts with the component, min/max should be a local date with no time so they can be compared.

  #### Returns Promise<string>

  The value of `max` property.

  Inherited from OjInputDateBase.getMax

### getMessagesCustom

- getMessagesCustom(): Promise<object[]>

- Gets the value of `messagesCustom` property. A list of messages added by an application to the component. See the Help documentation for more information.

  #### Returns Promise<object[]>

  The value of `messagesCustom` property.

  Inherited from OjInputDateBase.getMessagesCustom

### getMin

- getMin(): Promise<string>

- Gets the value of `min` property. The minimum selectable date, in ISO string format.

  #### Returns Promise<string>

  The value of `min` property.

  Inherited from OjInputDateBase.getMin

### getName

- getName(): Promise<string>

- Gets the value of `name` property. Specifies the name of the component.

  ### Deprecated

  Since 6.0.0. JET does not use form submit, so this is not needed.

  #### Returns Promise<string>

  The value of `name` property.

  Inherited from OjInputDateBase.getName

### getPickerAttributes

- getPickerAttributes(): Promise<PickerAttributes>

- Gets the value of `pickerAttributes` property. Specifies attributes to be set on the picker DOM element when it is launched. See the Help documentation for more information.

  #### Returns Promise<PickerAttributes>

  The value of `pickerAttributes` property.

  Inherited from OjInputDateBase.getPickerAttributes

### getPlaceholder

- getPlaceholder(): Promise<string>

- Gets the value of `placeholder` property. The placeholder text to set on the element.

  #### Returns Promise<string>

  The value of `placeholder` property.

  Inherited from OjInputDateBase.getPlaceholder

### getProperty

- getProperty<T>(propertyName): Promise<T>

- Get a named property value from this component. This function will wait for the application's busy context to complete before attempting to get the property value.

  #### Type Parameters

  - #### T = string

  #### Parameters

  - ##### propertyName: string

    The name of the property

  #### Returns Promise<T>

  A Promise that yields a value for the named property.

  Inherited from OjInputDateBase.getProperty

### getRawValue

- getRawValue(): Promise<string>

- Gets the value of `rawValue` property. Read-only property used for retrieving the current value from the input field in string form. See the Help documentation for more information.

  #### Returns Promise<string>

  The value of `rawValue` property.

  Inherited from OjInputDateBase.getRawValue

### getReadonly

- getReadonly(): Promise<boolean>

- Gets the value of `readonly` property. Specifies whether the component is read-only. A read-only element cannot be modified, but user interaction is allowed. See the Help documentation for more information.

  #### Returns Promise<boolean>

  The value of `readonly` property.

  Inherited from OjInputDateBase.getReadonly

### getRect

- getRect(): Promise<IRectangle>

- ### Inherit Doc

  #### Returns Promise<IRectangle>

  Inherited from OjInputDateBase.getRect

### getRenderMode

- getRenderMode(): Promise<string>

- Gets the value of `renderMode` property. Specifies whether to render the date picker in JET, or as a native picker control. See the Help documentation for more information.

  ### Deprecated

  Since 8.0.0. The "native" mode rendering is deprecated because JET is promoting a consistent Oracle UX over native look and feel in Redwood. Since this property takes only two values the property itself is deprecated. The theme variable "$inputDateTimeRenderModeOptionDefault" is also deprecated for the same reason.

  #### Returns Promise<string>

  The value of `renderMode` property.

  Inherited from OjInputDateBase.getRenderMode

### getRequired

- getRequired(): Promise<boolean>

- Gets the value of `required` property. Specifies whether the component is required or optional. See the Help documentation for more information.

  #### Returns Promise<boolean>

  The value of `required` property.

  Inherited from OjInputDateBase.getRequired

### getShadowRoot

- getShadowRoot(): ShadowRootPromise

- Get the shadow root of the current web element.

  #### Returns ShadowRootPromise

  A promise that will be resolved with the elements shadow root or rejected with NoSuchShadowRootError

  Inherited from OjInputDateBase.getShadowRoot

### getSize

- getSize(): Promise<ISize>

- ### Inherit Doc

  #### Returns Promise<ISize>

  Inherited from OjInputDateBase.getSize

### getTagName

- getTagName(): Promise<string>

- Schedules a command to query for the tag/node name of this element.

  #### Returns Promise<string>

  A promise that will be resolved with the element's tag name.

  Inherited from OjInputDateBase.getTagName

### getText

- getText(): Promise<string>

- ### Inherit Doc

  #### Returns Promise<string>

  Inherited from OjInputDateBase.getText

### getTranslations

- getTranslations(): Promise<Translations>

- Gets the value of `translations` property. A collection of translated resources from the translation bundle, or null if this component has no resources.

  #### Returns Promise<Translations>

  The value of `translations` property.

  Inherited from OjInputDateBase.getTranslations

### getUserAssistanceDensity

- getUserAssistanceDensity(): Promise<string>

- Gets the value of `userAssistanceDensity` property. Specifies the density of the form component's user assistance presentation.

  #### Returns Promise<string>

  The value of `userAssistanceDensity` property.

  Inherited from OjInputDateBase.getUserAssistanceDensity

### getValid

- getValid(): Promise<string>

- Gets the value of `valid` property. The validity state of the component

  #### Returns Promise<string>

  The value of `valid` property.

  Inherited from OjInputDateBase.getValid

### getValidators

- getValidators(): Promise<object[]>

- Gets the value of `validators` property. A list of validators used by the element, along with any implicit component validators, when performing validation. See the Help documentation for more information.

  #### Returns Promise<object[]>

  The value of `validators` property.

  Inherited from OjInputDateBase.getValidators

### getValue

- getValue(): Promise<string>

- Gets the value of `value` property. The value of the input date element, which must be an ISOString. See the Help documentation for more information.

  #### Returns Promise<string>

  The value of `value` property.

  Inherited from OjInputDateBase.getValue

### `Protected` hasSize

- hasSize(): Condition<Promise<boolean>>

- Create a wait condition that is satisfied when the element's DOM has a non-zero size.

  ### Deprecated

  Since 11.0.0. Call the appropriate WebElement method to test the size of the element.

  #### Returns Condition<Promise<boolean>>

  The Condition to be used with driver.wait() that's satisfied when the element's DOM has a non-zero size.

  Inherited from OjInputDateBase.hasSize

### `Protected` hasVisibility

- hasVisibility(): Condition<Promise<boolean>>

- Create a wait condition that is satisfid when the element is visible. The condition is satisfied when the element is displayed, as reported by #isDisplayed, and is scrolled into view. This is method is deprecated. Use WebElement.isDisplayed instead to test the display of the element, and scroll it into view if necessary.

  ### Deprecated

  #### Returns Condition<Promise<boolean>>

  Inherited from OjInputDateBase.hasVisibility

### isDisplayed

- isDisplayed(): Promise<boolean>

- ### Inherit Doc

  #### Returns Promise<boolean>

  Inherited from OjInputDateBase.isDisplayed

### isEnabled

- isEnabled(): Promise<boolean>

- ### Inherit Doc

  #### Returns Promise<boolean>

  Inherited from OjInputDateBase.isEnabled

### isSelected

- isSelected(): Promise<boolean>

- ### Inherit Doc

  #### Returns Promise<boolean>

  Inherited from OjInputDateBase.isSelected

### sendKeys

- sendKeys(...varArgs): Promise<void>

- ### Inherit Doc

  #### Parameters

  - ##### `Rest` ...varArgs: (string | number | Promise<string | number>)[]

  #### Returns Promise<void>

  Inherited from OjInputDateBase.sendKeys

### serialize

- serialize(): Promise<IWebElementId>

- #### Returns Promise<IWebElementId>

  Inherited from OjInputDateBase.serialize

### `Protected` setProperty

- setProperty<T>(propertyName, value): Promise<void>

- Set a property value on the remote element. This function first waits for the BusyContext to clear before setting the property, then after setting, waits again to ensure that no additional busy states were created due to the property setting.

  #### Type Parameters

  - #### T = string

  #### Parameters

  - ##### propertyName: string

    The property name to set

  - ##### value: T

    The value to set for the property

  #### Returns Promise<void>

  A Promise which resolves when the remote property has been set to the value. Any value returned from the call to set the remote property is returned in the Promise.

  Inherited from OjInputDateBase.setProperty

### submit

- submit(): Promise<void>

- ### Inherit Doc

  #### Returns Promise<void>

  Inherited from OjInputDateBase.submit

### takeScreenshot

- takeScreenshot(optScroll?): Promise<string>

- ### Inherit Doc

  #### Parameters

  - ##### `Optional` optScroll: boolean

  #### Returns Promise<string>

  Inherited from OjInputDateBase.takeScreenshot

### whenBusyContextReady

- whenBusyContextReady(): Promise<void>

- Returns a Promise that is resolved when the application's busy state reports ready. This method checks only that the application's busy context is ready, and not that the DOM element is actually displayed or has a physical size, such as is the case with #whenReady. Operations which are read-only in nature should call this method prior to execution.

  #### Returns Promise<void>

  A Promise which is resolved when the page's busy state is ready.

  Inherited from OjInputDateBase.whenBusyContextReady

### whenReady

- whenReady(): Promise<void>

- Returns a Promise that is resolved when the element is ready for interaction--it is visible, has a size, and the app's busy context is ready. Operations on the DOM which rely on its physical location and size to be in a "ready" state should use this command, such as clicking, sending keys, locating child elements, and so on.

  #### Returns Promise<void>

  A Promise that's resolved when all conditions are met.

  Inherited from OjInputDateBase.whenReady

### `Static` buildId

- buildId(id, opt_noLegacy?): IWebElementId

- #### Parameters

  - ##### id: string

    The raw ID.

  - ##### `Optional` opt_noLegacy: boolean

    Whether to exclude the legacy element key.

  #### Returns IWebElementId

  The element ID for use with WebDriver's wire protocol.

  Inherited from OjInputDateBase.buildId

### `Static` equals

- equals(a, b): Promise<boolean>

- Compares two WebElements for equality.

  #### Parameters

  - ##### a: WebElement

    A WebElement.

  - ##### b: WebElement

    A WebElement.

  #### Returns Promise<boolean>

  A promise that will be resolved to whether the two WebElements are equal.

  Inherited from OjInputDateBase.equals

### `Static` extractId

- extractId(obj): string

- Extracts the encoded WebElement ID from the object.

  ### Throws

  if the object is not a valid encoded ID.

  #### Parameters

  - ##### obj: IWebElementId

    The object to extract the ID from.

  #### Returns string

  the extracted ID.

  Inherited from OjInputDateBase.extractId

### `Static` isId

- isId(obj): boolean

- #### Parameters

  - ##### obj: IWebElementId

    the object to test.

  #### Returns boolean

  whether the object is a valid encoded WebElement ID.

  Inherited from OjInputDateBase.isId

Generated using TypeDoc